class HardVFE(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  scatter : __torch__.mmcv.ops.scatter_points.DynamicScatter
  vfe_layers : __torch__.torch.nn.modules.container.ModuleList
  def forward(self: __torch__.mmdet3d.models.voxel_encoders.voxel_encoder.HardVFE,
    voxels: Tensor,
    num_points: Tensor,
    coors: Tensor) -> Tensor:
    vfe_layers = self.vfe_layers
    _0 = getattr(vfe_layers, "0")
    _1 = torch.slice(voxels, 0, 0, 9223372036854775807)
    _2 = torch.slice(_1, 1, 0, 9223372036854775807)
    _3 = torch.sum(torch.slice(_2, 2, 0, 3), [1], True)
    _4 = torch.view(torch.type_as(num_points, voxels), [-1, 1, 1])
    points_mean = torch.div(_3, _4)
    _5 = torch.slice(voxels, 0, 0, 9223372036854775807)
    _6 = torch.slice(_5, 1, 0, 9223372036854775807)
    f_cluster = torch.sub(torch.slice(_6, 2, 0, 3), points_mean)
    _7 = ops.prim.NumToTensor(torch.size(voxels, 0))
    _8 = int(_7)
    _9 = ops.prim.NumToTensor(torch.size(voxels, 1))
    f_center = torch.new_zeros(voxels, [_8, int(_9), 3], dtype=6, layout=0, device=torch.device("cuda:0"), pin_memory=False)
    _10 = torch.slice(voxels, 0, 0, 9223372036854775807)
    _11 = torch.slice(_10, 1, 0, 9223372036854775807)
    _12 = torch.select(_11, 2, 0)
    _13 = torch.slice(coors, 0, 0, 9223372036854775807)
    _14 = torch.type_as(torch.select(_13, 1, 3), voxels)
    _15 = torch.mul(torch.unsqueeze(_14, 1), CONSTANTS.c1)
    _16 = torch.sub(_12, torch.add(_15, CONSTANTS.c2))
    _17 = torch.slice(f_center, 0, 0, 9223372036854775807)
    _18 = torch.slice(_17, 1, 0, 9223372036854775807)
    _19 = torch.copy_(torch.select(_18, 2, 0), _16)
    _20 = torch.slice(voxels, 0, 0, 9223372036854775807)
    _21 = torch.slice(_20, 1, 0, 9223372036854775807)
    _22 = torch.select(_21, 2, 1)
    _23 = torch.slice(coors, 0, 0, 9223372036854775807)
    _24 = torch.type_as(torch.select(_23, 1, 2), voxels)
    _25 = torch.mul(torch.unsqueeze(_24, 1), CONSTANTS.c1)
    _26 = torch.sub(_22, torch.add(_25, CONSTANTS.c2))
    _27 = torch.slice(f_center, 0, 0, 9223372036854775807)
    _28 = torch.slice(_27, 1, 0, 9223372036854775807)
    _29 = torch.copy_(torch.select(_28, 2, 1), _26)
    _30 = torch.slice(voxels, 0, 0, 9223372036854775807)
    _31 = torch.slice(_30, 1, 0, 9223372036854775807)
    _32 = torch.select(_31, 2, 2)
    _33 = torch.slice(coors, 0, 0, 9223372036854775807)
    _34 = torch.type_as(torch.select(_33, 1, 1), voxels)
    _35 = torch.mul(torch.unsqueeze(_34, 1), CONSTANTS.c3)
    _36 = torch.sub(_32, torch.add(_35, CONSTANTS.c4))
    _37 = torch.slice(f_center, 0, 0, 9223372036854775807)
    _38 = torch.slice(_37, 1, 0, 9223372036854775807)
    _39 = torch.copy_(torch.select(_38, 2, 2), _36)
    voxel_feats = torch.cat([voxels, f_cluster, f_center], -1)
    max_num = ops.prim.NumToTensor(torch.size(voxel_feats, 1))
    _40 = annotate(number, max_num)
    actual_num = torch.unsqueeze(num_points, 1)
    _41 = torch.arange(_40, dtype=3, layout=0, device=torch.device("cuda:0"), pin_memory=False)
    max_num0 = torch.view(_41, [1, -1])
    actual_num0 = torch.to(actual_num, 3)
    mask = torch.gt(actual_num0, max_num0)
    _42 = torch.type_as(torch.unsqueeze(mask, -1), voxel_feats)
    inputs = torch.mul_(voxel_feats, _42)
    return (_0).forward(inputs, )
